<?php
/**
* HELIUM V Synchronisation Modul for Magento 1.7.x
*
* Copyright (C) 2013 HELIUM V IT-Solutions GmbH
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU Affero General Public License as
* published by the Free Software Foundation, either version 3 of the
* License, or (at your option) any later version.
*
* According to sec. 7 of the GNU Affero General Public License, version 3,
* the terms of the AGPL are supplemented with the following terms:
*
* "Helium V" and "Helium 5" are registered trademarks of HELIUM V IT-Solutions GmbH.
* The licensing of the Program under the AGPL does not imply a trademark license.
* Therefore any rights, title and interest in our trademarks remain entirely with us.
* If you want to propagate modified versions of the Program under the
* name "Helium V" or "Helium 5", you may only do so if you have a written permission
* by Helium V IT-Solutions GmbH (to acquire a permission please contact
* Helium V IT-Solutions at trademark@heliumv.com).
*      
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Affero General Public License for more details.
*
* You should have received a copy of the GNU Affero General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
* 
* @category Heliumv
* @package  Heliumv_Synchronization
* @author   Maximilian Hehenwarter <developers@heliumv.com>
* @license  http://www.gnu.org/licenses/  Affero General Public License (AGPL 3.0) 
*/

/**
 * HeliumV Magento Sync Controller, Zentrale Classe für alle Backend GUI Aufrufe
 */
class Heliumv_Synchronization_AjaxController extends Mage_Core_Controller_Front_Action {


    /**
     * aufruf artikel und kategorie sync für alle elemente
     *
     * @return void
     */
    public function syncAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        //aufruf artikel und kategorie sync für alle elemente
        $this->loadLayout(); //Laden des layout
        $artikel_obj=new Heliumv_Synchronization_Model_Article();
        $artikel_obj->doArticleSync("full");
        $this->renderLayout(); //ausgabe des neuen layouts, wird für popupanzeige benötigt
        
    }
    
    


    /**
    * aufruf artikel und kategorie sync für seit TS geänderte elemente
    */
    public function updateAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        //aufruf artikel und kategorie sync für seit TS geänderte elemente
        $this->loadLayout(); //Laden des layout
        $artikel_obj=new Heliumv_Synchronization_Model_Article();
        $artikel_obj->doArticleSync("update");
        $this->renderLayout(); //ausgabe des neuen layouts, wird für popupanzeige benötigt
    }
    


    /**
    * alte funktion, wird nicht mehr gewartet oder verwendet 
    */
    /*public function updateAction_old() {

        
        Mage::log('############### Start - Sync only Updates');
        $options = array(
            'trace' => 1
        );
        Heliumv_Synchronization_AjaxController::$logonData = $this->initConfig();
        
        //ermittle letztgültigen sync zeitstempel
        //soap format <changedDateTime>2013-02-04 17:22:00</changedDateTime>
        $ts_sync=gmdate("Y-m-d H:i:s"); //initialwert utc time setzen
        $ts_last_sync=Mage::getStoreConfig('heliumvsynchronization/synctools/last_sync_ts');
        if(isset($ts_last_sync) and $ts_last_sync!="" and strtotime($ts_last_sync)>0)
        {
            $ts_sync=$ts_last_sync;  
            //TODO: Debug - setze manuelles syncdate
            //$ts_sync="2013-03-10 18:40:47"; //neuer test
            //$ts_sync="2013-03-10 13:28:47"; //ein artikel
            //$ts_sync="2013-02-10 13:28:47"; //zwei artikel
            //$ts_sync="2013-02-04 17:33:01"; //neuer test
        }
        mage::log("Verwende last_sync_ts ".$ts_sync);
        
        Heliumv_Synchronization_AjaxController::$client = new SoapClient(Mage::getStoreConfig('heliumvsynchronization/heliumvconnect/server_url'),$options);
        
        try {
      
            set_time_limit(Mage::getStoreConfig('heliumvsynchronization/heliumvconnect/soap_timeout'));
            
       
            $result = Heliumv_Synchronization_AjaxController::$client->getItemsChanged(array(
                'arg0' => Heliumv_Synchronization_AjaxController::$logonData,
                'changedDateTime' => $ts_sync)); 
            if ($result->return->rc == 0 && isset($result->return->items)) {
           
                
                //debug flag, nur breits vorhandene artikel aktualisieren
                //$known_only=Mage::getStoreConfig('heliumvsynchronization/synctools/update_only_known_articles');
                $known_only=0; //flag aus konfig rausgegeben
                foreach ($result->return->items as $item) {
                
                    set_time_limit(Mage::getStoreConfig('heliumvsynchronization/heliumvconnect/soap_timeout'));
                    
                  
                    $item_id=null;
                    //TODO: debug weg
                    $debug_count=count($result->return->items->id);
                    if(isset($result->return->items->id) and count($result->return->items->id)==1)
                    {
                        $item_id=$result->return->items->id; 
                        $result->return=null; //um weitere durchläufe zu verhindern         
                    }
                    else
                    {
                        //TODO: testfall mit 2 artikeln offen
                        $item_id=$item->id;       
                    }
                    
                    if($item_id!=null and $item_id!="")
                    {
                        $item_result = Heliumv_Synchronization_AjaxController::$client->getItemFindById(array(
                            'arg0' => Heliumv_Synchronization_AjaxController::$logonData,
                            'id' => $item_id)
                        );
                    }

                    if ($item_result->return->rc == 0 && $item_id!=null) 
                    {
                
                        $bme_cat_info = simplexml_load_string($item_result->return->item->bmeCatInfo);

                        $product = $bme_cat_info->T_NEW_CATALOG[0]->PRODUCT[0];
                        $image = $item_result->return->item->image ? $item_result->return->item->image : NULL;

              
                        $pid_item = (string) $product->PRODUCT_DETAILS[0]->INTERNATIONAL_PID;

                        try {
                            //TODO: Absturz wiso??
                            //$get_item = Mage::getModel('catalog/product')->load('ExternalPid', $pid_item);
                            
                            
                            //initialisierung
                            $store_id=Mage::app()->getStore()->getId();
                            
                            //schrit1: interne produktid ermitteln
                            $get_item_initial=$this->convertExternalIDtoProductID($pid_item);
                            Mage::log("Convertiere externe ID ".$pid_item." zu interner ID ".$get_item_initial." ");

                            
                            //bestehender artikel existiert oder alle updaten
                            if ($get_item_initial || $known_only==false) {
                                
                                if(!$get_item_initial)
                                    Mage::log('Updating existing Article: ' . $pid_item);
                                else
                                    Mage::log('Create new Article: ' . $pid_item);    
                                
                                //schritt2: neues produkt initialisieren
                                $get_item = Mage::getModel('catalog/product');
                                $get_item->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
                    

                                //vorgang für neue produkte
                                if(!$get_item_initial)
                                {
                                    //schritt3 id für db insert ermitteln: 
                                    $get_item->setAttributeSetId($this->getDefaultAttributeSetId('catalog/product'));     
                                    //$product->setAttributeSetId(Mage::getModel('catalog/product')->getResource()->getEntityType()->getDefaultAttributeSetId()); 
                                    
                                    //basic
                                    $get_item->setSyncTs(strtotime('now'));
                                    // update product information
                                    $get_item->setName($product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT);
                                    $get_item->setDescription($product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG ? $product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG : $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT);
                                    $get_item->setShortDescription($product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT);
                                    $get_item->setPrice($product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->PRICE_AMOUNT);
                                    $get_item->setSku($item_result->return->item->cnr);
                                    
                                    //stock
                                    $get_item->setStockData(array(
                                            'is_in_stock' => 1,
                                            'qty' => 8888
                                        ));
                                    
                                    //zusätzlich
                                    $get_item->setStatus(Mage_Catalog_Model_Product_Status::STATUS_ENABLED);
                                    $get_item->setTypeId('simple');
                                    $get_item->setExternalPid($pid_item);
                                }
                                else
                                {
                                    //bestehende daten laden
                                    $get_item->load($get_item_initial);
                                    
                         
                                    
                                    
                                    
                                    //vorgang für bestehende produkte - 2. versuch
                                    $data['sync_ts'] = strtotime('now');
                                    $data['name'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
                                    $data['description'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG ? $product->PRODUCT_DETAILS[0]->DESCRIPTION_LONG : $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
                                    $data['short_description'] = $product->PRODUCT_DETAILS[0]->DESCRIPTION_SHORT;
                                    $data['price'] = $product->PRODUCT_PRICE_DETAILS->PRODUCT_PRICE->PRICE_AMOUNT;
                                    $data['sku'] = $item_result->return->item->cnr;
                                    $data['status'] = Mage_Catalog_Model_Product_Status::STATUS_ENABLED;
                                    
                                    //diverses
                                    $data['attribute_set_id'] = $this->getDefaultAttributeSetId('catalog/product');
                                    $data['website_ids'] = array_keys(Mage::app()->getWebsites());
                                    $data['type_id'] = Mage_Catalog_Model_Product_Type::TYPE_SIMPLE;
                                    
                                    $get_item->addData($data);
                                    
                                    
                                    
                                    
                                }
                                

                                
                                
                                //TODO: alternative stock save benötigt da sonnst probleme mit keys?
                                //key error bei insert wegen cataloginventory_stock_item, hinweis aus doku p184 gefunden
                                //siehe auch http://stackoverflow.com/questions/11139516/cannot-update-stock-item-quantity-for-a-product-in-magento-1-6-2
                                
                                
                                $stockItem = Mage::getModel('cataloginventory/stock_item');
                                $stockItem->setAttributeSetId($this->getDefaultAttributeSetId('cataloginventory/stock_item'));    
                                $stockItem->assignProduct($get_item);
                                //$stockItem->setData('stock_id', 1);
                                $stockItem->setData('store_id', $store_id);
                                $stockItem->setData('qty', 9999);
                                $stockItem->setData('is_in_stock', 1);
                                //TODO: wirft sql error
                                $stockItem->save();
                                
                                
                                
                                
                                //TODO: beispiel produkt update von http://magento4u.wordpress.com/tag/product-quantity-update/
                                // call product model and create product object
                                $product2    = Mage::getModel('catalog/product');
                                // Load product using product id
                                $product2 ->load($get_item->id);
                                // get product's general info such price, status, description
                                $productInfoData = $product2->getData();
                                // update general info using new data
                                $productInfoData['price'] = 11;
                                $productInfoData['description'] = 'Testing product update';
                                $productInfoData['status'] = 1;
                                // then set product's general info to update
                                $product2->addData($productInfoData);
                                // get product's stock data such quantity, in_stock etc
                                $stockData = $product2->getStockData();
                                // update stock data using new data
                                $stockData['qty'] = 356;
                                $stockData['is_in_stock'] = 1;
                                // then set product's stock data to update
                                $product2->setStockData($stockData);
                                // call save() method to save your product with updated data
                                $product2->setAttributeSetId($this->getDefaultAttributeSetId('catalog/product'));  
                                $product2->setTypeId('simple');
                                //$product->save();
                                
                                
                                
                                
                                
                                // versuche artikel zu speichern
                                try {
                                    $get_item->save();
                                } catch (Exception $ex) {
                                    Mage::log("Error bei Speichern von HV Artikel ID".$item_id);
                                    Mage::log($ex->getMessage());
                                }
       
                                if ($image) {
                                    $source = $product->MIME_INFO->MIME->MIME_SOURCE;
                                    $img = imagecreatefromstring($image);
                                    if ($img !== false) {
                                        $path = Mage::getBaseDir('media') . DS . 'tmp' . DS;
                                        if(!file_exists($path))
                                            mkdir($path);
                                        header('Content-Type: ' . $product->MIME_INFO->MIME->MIME_TYPE);
                                        imagejpeg($img, $path . $source);
                                        imagedestroy($img);
                                  
                                        try {
                                            $get_item->addImageToMediaGallery($path . $source, array("thumbnail", "small_image", "image"), true);
                                        } catch (Exception $ex) {
                                            Mage::log($ex->getMessage());
                                        }
                                    }
                                }
                            } else {

                            
                                
                            }
                            
                          
                            $indexingProcesses = Mage::getSingleton('index/indexer')->getProcessesCollection();
                            foreach ($indexingProcesses as $process) {
                                $process->reindexEverything();
                            }
                        } catch (Exception $ex) {
                            $response = array('error' => true, 'message' => $ex->getMessage());
                        }

                        $response = array(
                            'message' => $this->__('Kategorien wurden importiert und angelegt.'));
                         

                    } //if rc=0 und daten vorhanden und artikel!=null
                } //foreach item
                
            } else {
                Mage::log(Heliumv_Synchronization_AjaxController::$client->__getLastRequest());
                $response = array('error' => true, 'message' => $result);
            }
            
            if ($result->return->rc == 0)
            {
                //setzen zeitstempel nach erfolgreichem import, Call rc=0 und keine exceptions in hauptroutine
                //info von http://www.magentocommerce.com/boards/viewthread/44792/
                $ts_sync_new=gmdate("Y-m-d H:i:s");
                Mage::getConfig()->saveConfig('heliumvsynchronization/synctools/last_sync_ts', $ts_sync_new );
                Mage::getConfig()->reinit();
                Mage::app()->reinitStores();
                
                Mage::log("Setze Zeitstempel letzter Artikelsync von ".$ts_sync." auf ".$ts_sync_new);    
            }
            
        } catch (SoapFault $ex) {
            $response = array('error' => true, 'message' => $ex->getMessage());
        }
      
        if (isset($response) && is_array($response)) {
            $response = Mage::helper('core')->jsonEncode($response);
            $this->getResponse()->setBody($response);
        }  
    }       */

    /**
    * Löscht alle Producte und Kategorien
    */
    public function deleteAction() 
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $artikel_obj= new Heliumv_Synchronization_Model_Article();
        $artikel_obj->deleteAllArticlesAndCategories();
        $this->renderLayout(); //ausgabe des neuen layouts, wird für popupanzeige benötigt
        
    }

    
    /**
    * wird aufgerufen wenn button sync orders in backend gedrückt wird, kommt von Syncorder.php bzw button_syncorder.phtml
    * Syncronisiert alle moffenen bestellungen nach HV
    */
    public function syncorderAction() 
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $order_model= new Heliumv_Synchronization_Model_Order; //definiert unter Model/Order.php
        $order_model->doOrderSync();
        $this->renderLayout(); //ausgabe des neuen layouts, wird für popupanzeige benötigt
    }
    

    
    
    /**
    * Wird durch Button "test" aus Backend aufgerufen und dient um neue Funktionalitäten zu prüfen/zu debuggen
    */
    public function testAction()
    {
        //TODO 1: done - für auslieferungsversion umsetzen
        return null;
        
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        
        
        $temp=Heliumv_Synchronization_Helper_Master::checkPHPVoraussetzungen();
        
        
        
        
        
        
        $obj=new Heliumv_Synchronization_Model_Article();
        $obj->processArticleDetails(6900);
        $obj->processArticleDetails(5281);
        //$obj->processCategoryDetails(25,2);
        
        
        //$obj->checkAllCategoryPaths();
        
        return null;
        
        $obj=new Heliumv_Synchronization_Helper_Master();
        //$obj->sendErrorToHV("999","testöööääää",3,"undefined",11111,8475847847);
        
        return null;
        
        
        
        
        
        
        
        $obj = new Heliumv_Synchronization_Model_Customer();
        //$obj->doCustomerSync("full");
        $trturn=$obj->processCustomerDetails(21);
        
        
        $obj=new Heliumv_Synchronization_Model_Order();
        $obj->doOrderSync();
        
        
        Heliumv_Synchronization_Helper_Master::sendErrorToHV("988","test error interface",3,"undefined",343453,"viurguertfg");
        return null;
        
        $obj= new Heliumv_Synchronization_Model_Customer();
        
        //$obj->getCustomerGroupName(11);
        
        
        $trturn=$obj->getCustomerDetails(21);
        
        
        
        //$obj->doCategorySync("full");
        
        //$obj->getArticleDetails(2476);
        
        return null;
        
        $obj= new Heliumv_Synchronization_Model_Customer();
        //$obj->processCustomerDetails(938);
        
        /*$obj=mage::getmodel("catalog/product");
        $obj->setStoreId(Heliumv_Synchronization_Helper_Master::getStoreId());
        $obj->setAttributeSetId(Heliumv_Synchronization_Helper_Master::getDefaultAttributeSetId('catalog/product'));
        $obj->load(745);
        $category_ids=array();
        array_push($category_ids, 4);
        $data['category_ids']=$category_ids;
        $obj->addData($data);
        $obj->save();
        
        return null; */
        
        
        $obj=new Heliumv_Synchronization_Model_Article();
        $obj->processPreisIndex();
        
        //$obj->test_articlesave_display_in_shop();
        
        //$obj->test("blubb");
        
        $obj->processArticleDetails(3574);
        
        return null;
        
        
        /* //sammlung möglicher ursachen
        -- `cataloginventory_stock_status`
        -- `catalogsearch_fulltext`
        -- `catalog_category_product_index`
        -- `catalog_product_entity_int` 
        -- `catalog_product_entity_varchar` 
        -- `catalog_product_flat_1`
        -- `catalog_product_index_eav`
        -- `catalog_product_index_eav_tmp`
        -- `catalog_product_website`
        */
        
        
        
        
        
        
        
        $indexingProcesses = Mage::getSingleton('index/indexer')->getProcessesCollection();
        foreach ($indexingProcesses as $process)
        {
            $process->reindexEverything();
        }
        
        $obj=mage::getmodel("catalog/product")->load(738);
        $obj->setCategoryIds(array("4"));
        $obj->save();
         
        
        return null;
        
        
        $obj= new Heliumv_Synchronization_Model_Scheduler();
        $obj->runScheduler();

        
        
        
        
        //$obj->processCategoryDetails(19,12); //12=parent, 19=child
        
        return null;
        //$obj->test_fast_articlesave_paralell();
        
        
        
        //$obj->processArticleDetails("3589");
        //$obj->processArticleDetails("789");
        $obj->processArticleDetails("3498");
        //$obj->processArticleDetails("3830");
        
        return null;
        
        
        $obj=new Heliumv_Synchronization_Model_Customer();
        $obj->doCustomerSync("update");
        
        /*
        //test neues multithread object erstellen und speichern
        $thread=new Heliumv_Synchronization_Model_Scheduler();
        $thread->setData("status","1");
        $thread->setData("class","Heliumv_Synchronization_Model_Article");
        $thread->setData("call","test");
        //$thread->setData("arguments",serialize(rand(1,1000)));
        $thread->setData("arguments",serialize(array("1","2","3")));
        $thread->save();
        mage::log("Thread mit ID ".$thread->getId()." angelegt.");     
        */
        
        /*
        //rufe verarbeitung auf
        $thread2=new Heliumv_Synchronization_Model_Multithread();
        $thread2->processThread();
          */
        
        
        /*$obj=mage::getModel("catalog/product")->load(50);
        Heliumv_Synchronization_Helper_Master::debugLog("test_obj50.log",$obj);
        $obj=mage::getModel("catalog/product")->load(31);
        Heliumv_Synchronization_Helper_Master::debugLog("test_obj31.log",$obj);
        */
        
        
        $test[]=Heliumv_Synchronization_Helper_Master::getWebsiteCode();
        $test[]=Heliumv_Synchronization_Helper_Master::getWebsiteId();
        $test[]=Heliumv_Synchronization_Helper_Master::getStoreCode();
        $test[]=Heliumv_Synchronization_Helper_Master::getStoreId();
        
        //löse problem mit artikelbildern
        $obj = new Heliumv_Synchronization_Model_Article();
        //$obj->saveArticlePictures(1001,$obj->getArticleDetails(3498));
        //$test=$obj->createDummyArticle();
        //$obj->processArticleDetails(895);
        
        //$obj->test_fast_articlesave();
        
        $obj = new Heliumv_Synchronization_Model_Customer();
        //$obj->test_fast_save_customer();
        
        
        
        
        //teste scheduler aufruf
        $obj=new Heliumv_Synchronization_Model_Scheduler();
        //$obj->runScheduler();
        
        //$obj->executeFunction(761);
        
        /*
        //teste erstellung und async verarbeitung von category bzw artikel
        $external_gid=11;
        $magento_parent_id=1;
        $external_pid=2458;
        $obj=new Heliumv_Synchronization_Model_Scheduler();
        //$scheduler_id=$obj->createSchedulerElement("Heliumv_Synchronization_Model_Article","processCategoryDetails",array($external_gid,$magento_parent_id));
        $scheduler_id=$obj->createSchedulerElement("Heliumv_Synchronization_Model_Article","processArticleDetails",array($external_pid));
        $return=$obj->executeFunction($scheduler_id);
        */
        
        
        //testaufruf von category sync
        //$articlesync=new Heliumv_Synchronization_Model_Article();
        //$articlesync->doArticleSync("full",0);
        //$articlesync->saveCategory(1,"test",123,2458,1);  
        
        //$articlesync->processCategoryDetails(11,1);
        
          
          
        //teste order xml erstellung für order 1
        /*$order = Mage::getModel('sales/order')->load(5);                
        $order_model=new Heliumv_Synchronization_Model_Order();
        $xml=$order_model->createOrderXML($order); */
        
        //$obj=new Heliumv_Synchronization_Model_Scheduler();
        //$obj->createSchedulerElement("Heliumv_Synchronization_Model_Article","test","blubb");
        //$obj->runScheduler();
        
    }
    
    /**
    * Wird durch Button "Customer Del" aus Backend aufgerufen und löscht alle durch HV impoirtierten Kunden
    */
    public function customerdelAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $obj=new Heliumv_Synchronization_Model_Customer();
        $obj->deleteImportedCustomers();    
        $this->renderLayout(); //aktualisierung darstellen, wird für popupanzeige benötigt
    }
    
    /**
    * Wird durch Button "Customer Import" aus Backend aufgerufen und importiert alle Kunden aus HV
    */
    public function customerimportAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $obj=new Heliumv_Synchronization_Model_Customer();
        $obj->doCustomerSync("full");
        $this->renderLayout(); //aktualisierung darstellen, wird für popupanzeige benötigt
    }
    
    /**
    * Wird durch Button "Customer Update" aus Backend aufgerufen und aktualisiert alle Kunden seit TS aus HV
    */
    public function customerupdateAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $obj=new Heliumv_Synchronization_Model_Customer();
        $obj->doCustomerSync("update");
        $this->renderLayout(); //aktualisierung darstellen, wird für popupanzeige benötigt
    }
    
    /**
    * Wird durch Button "Category Import" aus Backend aufgerufen und importiert alle Shopgruppeb bzw. Kategorien von HV nach Magento
    */
    public function categoryimportAction()
    {
        //prüfe ob storeid richtig gesetzt ist    
        Heliumv_Synchronization_Helper_Master::checkAndSetStoreId();
        
        $this->loadLayout(); //Laden des layout
        $obj=new Heliumv_Synchronization_Model_Article();
        $obj->doCategorySync("full");
        $this->renderLayout(); //aktualisierung darstellen, wird für popupanzeige benötigt
    }
    
    /**
    * Wird durch Button "Debug -> Manual Setup" aus Backend aufgerufen und führt Setup Script erneut aus (sinnvoll z.B. wenn Setup manuell geändert wurde)
    */
    public function manualsetupAction()
    {
        
        $path=mage::getBaseDir('app') .DIRECTORY_SEPARATOR.'code'.DIRECTORY_SEPARATOR.'local'.DIRECTORY_SEPARATOR.'Heliumv'.DIRECTORY_SEPARATOR.'Synchronization'.DIRECTORY_SEPARATOR.'sql'.DIRECTORY_SEPARATOR.'synchronization_setup'.DIRECTORY_SEPARATOR;
        
        include_once($path."mysql4-install-0.0.1.php");
        
    }
    
    
    

}